// PGL interaciton engine
// 
// @ TODO
// data resolution, 44? not 33?
// content testing
// 01 write static animations, sinus, simple waves, etc.
// 02 find peak value in mic data
// 03 center animations to peak value in mic data
// scale input 0.01 - 100 
// 1.0  / 1.1 or * 1.1

// network
import processing.net.*;

boolean live=false;
boolean fakesensors=true;
boolean firstRun = false;
String inString;
float[] micArray = new float[350];
float micArrayScale = 1.0;
float[] gotoArray = new float[350];
float[] beepArray = new float[350];
float[] solarArray = new float[350];
float solarArrayScale = 1.0;
float solarArrayOffset = 1.0;
float[] tempArray = new float[350];
float[] battArray = new float[350];
// colorArray stores actual gate values
float[] colorArray = new float[350];

// sensing variables
int peakMic; // position of peak in micArray 
// Pablo Added 
int myxpos=10;
int myypos=8;

// function variables
float bouncingBallX = 5;
float bouncingBallY = 5;
float bouncingBallXSpeed = random(0.2, 0.4);
float bouncingBallYSpeed = random(0.2, 0.4);
int[] sketchX = new int[324];
int[] sketchY = new int[324];
int sketchPos = 0;

// cycle through content
int content = 0;

color[] pglColor = new color[34];
int colorResolution = 33;

// global counter to be used in animation, +1 each frame 
float counter = 0;
float counterSpeed = 0.0;
//
int[] rgbArray = new int[3];

// color bar for color picker image
PImage colorBarImage;
PImage backgroundImage;

// Font setup
PFont font;

// Soundbouncer setup
int soundbouncex = 9;
int soundbouncey = 9;
int soundbounceframe = 0;
float[] beeplessArray = new float[350];
String soundpath = "eeeennnenenenenennnnneeeeessssssswswswswswswswwwwwwwwsswwwwnnnnnnnnnnenenenen";
int soundpathlength = soundpath.length();


void setup() {
	size(600, 200);
	colorMode(RGB, 255);
	framerate(10);
	backgroundImage = loadImage("interface.gif");
	image(backgroundImage, 0, 0);
	setupPglColors();
	font = loadFont("sans10.vlw"); 
	textFont(font, 10);
	soundBouncerSetup();
}

void draw() {
	counter += counterSpeed;
	image(backgroundImage, 0, 0);
	
	// netFrame handels all server communcation. 
	// comment w printSensors() for local testing

        if(live) netFrame();
        if(fakesensors)
        {
           fakeSensors();
           fakeSensorsArray();
        }
	//printSensors();
	
	
	// choose animation
	if(true) {
		switch(content)
		{
		case 0: 
			//();
			text("none", 470, 33);
			break; 
		case 1: 
			trivialmachine();
			text("trivialmachine(UsmanH)", 470, 33);
			break; 
		case 2: 
			notquitenontrivialmachine();
			text("notquitenontrivialmachine(UsmanH)", 470, 33);
			break; 
		case 3: 
			soundBouncer();
			text("soundBouncer(UsmanH)", 470, 33);
			break; 
		case 4: 
			gradient();
			text("gradient()", 470, 33);
			break; 
		case 5: 
			waves();
			text("waves", 470, 33);
			break; 
		case 6:
			blackHole();
			text("blackHole", 470, 33);
			break; 
		case 7:
			blackHoleMic();
			text("blackHoleMic", 470, 33);
			break; 
		case 8:
			sketch();
			text("sketch", 470, 33);
			break; 
		case 9:
			copyMic();
			text("bouncingBall", 470, 33);
			break; 
		case 10:
			me_color();
			text("me_color(PabloM)", 470, 33);
			break; 
		case 11:
			bouncingBall();
			text("bouncingBall", 470, 33);
			break; 
		case 12:
			bouncingBall();
			text("bouncingBall", 470, 33);
			break; 
		case 13:
			bouncingBall();
			text("bouncingBall", 470, 33);
			break; 
		case 14:
			bouncingBall();
			text("bouncingBall", 470, 33);
			break; 
		case 15:
			bouncingBall();
			text("bouncingBall", 470, 33);
			break; 
		case 16:
			bouncingBall();
			text("bouncingBall", 470, 33);
			break; 
		}
	}
	inputToOutput();
        if(live) netFrame();
	displayPglColors();
	magnifyView();
	printCurrentFrame();
}
// sensing #################################################################

void findPeakMic() {
	float peakFind = 0;
	for (int i=0; i<305; i++){
		if (micArray[i] > peakFind) {
			peakFind = micArray[i];
			peakMic = i;			
		}
	}
}

void findCenterMic(){	// not ready
	float temp[] = new float[350];
	temp = sort(micArray);
	temp = reverse(temp);
	// find positions of the first 10 values in micArray
	// this is buggy as identical values will be interchangeable
	
	for (int i=0; i<9; i++) {
		// indexOf(
		
	}
}

void scaleMicArray(){


}

// animations #################################################################

void beepAll() {
	for (int i=0; i<20; i++){
	  beepArray[i]=60;
	  println("beeep");
	}
}


void gotoAll() {
	for (int i=0; i<20; i++){
	  gotoArray[i]=5;
	  println("goto");
	}
}

// Usman
void soundBouncerSetup(){
	for (int i=0; i<18 * 18; i++){
		beepArray[i]=0;
		beeplessArray[i]=0;
	}
}

// Usman
void soundBouncer(){
	arraycopy(beeplessArray,beepArray);
	//beepArray[0] = 60;
	switch (soundpath.charAt(soundbounceframe % soundpathlength)){
		case 'n':
			if ((soundbouncex++)>17) { 
				soundbouncex = 1; 
			}
			break;
		
		case 's':
			if ((soundbouncex--)<1) { 
				soundbouncex = 18; 
			}
			break;
		
		case 'e':
			if ((soundbouncey++)>17) { 
				soundbouncey = 1; 
			}
			break;
		
		case 'w':
			if ((soundbouncey--)<1) { 
				soundbouncey = 18; 
			}
			break;
	
	}
	
	println("soundbouncex: " + soundbouncex + "... soundbouncey: " + soundbouncey);
	
	beepArray[soundbouncex*18 + soundbouncey] = 80;
	soundbounceframe++;
	
	// display it
  	for (int y = 0; y < 18; y++) {
		for (int x = 0; x < 18; x++) {
			color c = color(beepArray[int((y * 18) + x)] * 7, 0, 0);
			//set(x, y, c);
		}
	}
  
}

// Usman
void trivialmachine(){

	for (int i=0; i<18 * 18; i++){
	
		gotoArray[i] =  ( micArray[i] / 3 ) % 32;
		beepArray[i] =  solarArray[i] * 22 ;
	
	//println(gotoArray[i]);
	}
    // println("vf done");
   	for (int y = 0; y < 18; y++) {
		for (int x = 0; x < 18; x++) {
			color c = color(gotoArray[int((y * 18) + x)] * 7, 0, 0);
			set(x, y, c);
		}
	}

}

// Usman
void notquitenontrivialmachine(){
	for (int i=0; i<18 * 18; i++){
		int gmscaler = second() % 10; //gotoarray mic scaler
		int gsscaler = minute() % 3; // gotoarray solar scaler
		int bmscaler = 1/ (minute() % 3 + 1); // beeparray micscaler
		int bsscaler = second() % 50;
		
		gotoArray[i] = (gmscaler * micArray[i] + gsscaler * solarArray[i]) % 32;
		beepArray[i] = (bmscaler * micArray[i] + bsscaler * solarArray[i]) % 40 + 40 ;
		//println(gotoArray[i]);
	}
	
	for (int y = 0; y < 18; y++) {
		for (int x = 0; x < 18; x++) {
			color c = color(gotoArray[int((y * 18) + x)] * 7, 0, 0);
			set(x, y, c);
		}
	}
	//print(gotoArray);
	//println("vf done");

}



// not ready, too slow?.
void sketch() {
	if (mousePressed && mouseX > 9 && mouseX < 29 && mouseY > 9 && mouseY < 29){
		sketchPos += 1;
		if (sketchPos > 324) sketchPos = 0;
		sketchX[sketchPos] = mouseX;
		sketchY[sketchPos] = mouseY;
	}
	fill(0, 0, 0);
	rect(0, 0, 18, 18);
	fill(125, 125, 125);
	for (int i=0; i<324; i++){
		rect(sketchX[i], sketchY[i], 1, 1);
	}
}

// 18 by 18 field bouncing ball
void bouncingBall(){
	bouncingBallX = (bouncingBallX + bouncingBallXSpeed);
	bouncingBallY = (bouncingBallY + bouncingBallYSpeed);
	if (bouncingBallX > 17 || bouncingBallX < 1){
		bouncingBallXSpeed *= -1;
	}
	if (bouncingBallY > 17 || bouncingBallY < 1){
		bouncingBallYSpeed *= -1;
	}
	
	fill(0, 0, 0);
	rect(0, 0, 18, 18);
	noStroke();
	fill(125, 125, 125);
	rect(int(bouncingBallX) + 0, int(bouncingBallY) + 0, 2, 2);
}

// 
void copyMic() {
	copy(100, 0, 18, 18, 0, 0, 18, 18);
}

// radial gradient, scaling not ready
void blackHole() {
	for (int y = 0; y < 18; y++) {
		for (int x = 0; x < 18; x++) {
			int distance = int(dist(x, y, 9, 9));
			int phase = int(abs(sin((distance + counter) / 5)) * 255);
			color c = color(phase, phase, phase);
			set(x, y, c);
		}
	}
}

void blackHoleMic() {
	// center around peakMic
	if (frameCount % 8 == 0) findPeakMic();
	int peakMicX;
	int peakMicY;
	if (peakMic != 0){
		peakMicX = int(peakMic % 18);
		peakMicY = int(floor(peakMic / 18));
	} else {
		peakMicX = 9;
		peakMicY = 9;
	}
	
	for (int y = 0; y < 18; y++) {
		for (int x = 0; x < 18; x++) {
			int distance = int(dist(x, y, peakMicX, peakMicY));
			int phase = int(abs(sin((distance + counter) / 5)) * 255);
			color c = color(phase, phase, phase);
			set(x, y, c);
		}
	}
}

// waves animation
void waves() {
	for (int y = 0; y < 18; y++) {
		for (int x = 0; x < 18; x++) {
			int distance = y;
			int phase = int((sin((distance + counter) / 5)) * 125) + 130;
			color c = color(phase, phase, phase);
			set(x, y, c);
		}
	}
}


// flat animation
void gradient() {
	for (int y = 0; y < 18; y++) {
		for (int x = 0; x < 18; x++) {
			int countint = (frameCount * 8) % 255;
			color c = color(countint, countint, countint);
			set(x, y, c);
		}
	}
}



// Pablo Added 
//an attempt to make a subjective color field depending of where one person is...
void me_color() {
	// center around peakMic
	if (frameCount % 8 == 0) findPeakMic();
	if (peakMic != 0){
		myxpos = int(peakMic % 18);
		myypos = int(floor(peakMic / 18));
	} else {
		myxpos = 9;
		myypos = 9;
	}
	float tanv;
	float dx,dy,dis;
	float val;
	//dis=60;
	//print ("-------------------------------- \n");
	for (int i=0; i<18; i++)
	{
		for (int j=0; j<18; j++)
		{
			dx=i-myxpos;
			dy=j-myypos;
			//tanv=dy/dx;
			 //NOT SOLVED!!! it should be simple...
			 val=32*atan2(dx,dy)/(2*PI);
			 if (val<0) val=(16+val)+16;
			 val = val * 7;
			//val=val<0 ? 32+val:val;
			//val=32*acos(dx/dis)/(2*PI);
			// print (val +"\n");
			//gotoArray[i*18+j]=32*atan(atang)/(2*PI);
			set(i,j,color((int)val,(int)val,(int)val));
			// set(i,j,(int)val);
		}
	}
}

void me_color_static() {
	float tanv;
	float dx,dy,dis;
	float val;
	for (int i=0; i<18; i++)
	{
		for (int j=0; j<18; j++)
		{
			dx=i-myxpos;
			dy=j-myypos;
			 val=32*atan2(dx,dy)/(2*PI);
			 if (val<0) val=(16+val)+16;
			 val = val * 7;
			set(i,j,color((int)val,(int)val,(int)val));
			// set(i,j,(int)val);
		}
	}
}
// End of Pablo 


// display #################################################################
void printCurrentFrame(){
	text("frame " + frameCount, 470, 10);
	text("speed(v+ b-) " + int(counterSpeed * 100), 470, 22);
	text("micScale(n+ m-) " + micArrayScale, 470, 44);
}

void setupPglColors() {
	
	for (int i = 0; i < 11; i++) {
		pglColor[i] = color(250 - (i*25), i * 25, 0);
	}
	
	for (int j = 0; j < 11; j++) {
		pglColor[j + 11] = color(0, 250 - (j*25), j * 25);
	}
	
	for (int k = 0; k < 11; k++) {
		pglColor[k + 22] = color(k * 25, 0, 250 - (k*25));
	}
}

void displayPglColors() {
	for (int i=0; i<33; i++) {
		noStroke();
		fill(i * 7.72727272);
		rect(200 + 8 * i, 0, 8, 15);
		//fill(pglColor[i]);
		fill(pglColor[int((i * 7.7272) / (255 / colorResolution)) % 33]);
		//int c = int(floor(i / (255 / colorResolution)) * (33 / colorResolution));
		//fill(pglColor[c]);
		
		rect(200 + 8 * i, 15, 8, 15);
		fill(0);
		text("Resolution(x+ c-): " + colorResolution, 300, 40);
	}
	
	
}

// convert the topleft window to PGL colored and send it to gotoArray
void inputToOutput(){
	// load the 18 by 18 corner image
	int[] pixelBuffer = new int[18 * 18]; 
	loadPixels();
	// read on the 0-.18 box
	for (int i=0; i<18 * 18; i++) {
		pixelBuffer[i] = pixels[i%18 + (width * floor(i / 18))];
	}
	
	// convert colors
	// colorResolution
    int d;
	for (int i=0; i<18 * 18; i++) {
        d=int(brightness(pixelBuffer[i]) / (255 / colorResolution)) % 33;
		pixelBuffer[i] = pglColor[d];
		gotoArray[i] = d;
	}

	
	// print to 20-38 box
	for (int i=0; i<18 * 18; i++) {
		pixels[20 + i%18 + (width * floor(i / 18))] = pixelBuffer[i];
	}
	updatePixels();

}

// display the data stored in micArray, solarArray
void printSensors() {
	int x = 0;
	int y = 0;
	//int z = second();
	float z = counter;
	float noiseScale = 0.18;
	
	// microphone
	for (int i = 0; i < 18 * 18; i++) {
		x = i % 18;
		y = floor(i / 18);
		if (micArray.length > 300){
			if (int(solarArray[i]) > 0) {
				stroke(0, 0, micArray[i] * 3);
			} else {
				stroke(125, 125, 125);	
			}
			point(x + 99, y + 0);
		}
	}
	
	// solar
	for (int i = 0; i < 18 * 18; i++) {
		x = i % 18;
		y = floor(i / 18);
		if (solarArray.length > 300){
			if (solarArray[i] > 0) {
				stroke(0, solarArray[i] * 100 - 100, 0);
			} else {
				stroke(125, 125, 125);	
			}
			point(x + 119, y + 0);
		}
	}

	
	// color
	for (int i = 0; i < 18 * 18; i++) {
		x = i % 18;
		y = floor(i / 18);
		if (solarArray.length > 300){
			if (solarArray[i] > 0) {
				stroke(pglColor[int(colorArray[i]) % 33]);
			} else {
				stroke(125, 125, 125);	
			}
			point(x + 40, y + 0);
		}
	}
}

void fakeSensors() {
	int x = 0;
	int y = 0;
	int z = second();
	float noiseScale = 0.15;
	for (int i = 0; i < 18 * 18; i++) {
		x = i % 18;
		y = floor(i / 18);
		stroke(noise(x*noiseScale, y*noiseScale, z*noiseScale) * 300 - 50);
		point(x + 99, y + 0);
	}
	
	noiseScale = 0.05;
	for (int i = 0; i < 18 * 18; i++) {
		x = i % 18;
		y = floor(i / 18);
		stroke(noise(x*noiseScale, y*noiseScale, z*noiseScale) * 300 - 50);
		point(x + 119, y + 0);
	}
}

// this is like fakesensors() but not written to screen -- it directly writes the sensor array
void fakeSensorsArray() {
  int x = 0;
  int y = 0;
  int z = second();
  float noiseScale = 0.15;
  for (int i = 0; i < 18 * 18; i++) {
    x = i % 18;
    y = floor(i / 18);

    micArray[i] = (noise(x*noiseScale, y*noiseScale, z*noiseScale) * 100 + 50);

  }

  noiseScale = 0.05;
  for (int i = 0; i < 18 * 18; i++) {
    x = i % 18;
    y = floor(i / 18);

    solarArray[i] = (noise(x*noiseScale, y*noiseScale, z*noiseScale) * 2 + 1);

  }
}

// to magnify the in out sensors boxes, 
// copy seems buggy, not 100% accurate
void magnifyView(){
	// copy(sx, sy, swidth, sheight, dx, dy, dwidth, dheight)
	copy(0, 0, 18, 18, 0, 70, 18 * 6, 18 * 6);
	copy(20, 0, 18, 18, 109, 70, 18 * 6, 18 * 6);
	copy(40, 0, 18, 18, 229, 70, 108, 108);
	copy(99, 0, 18, 18, 349, 70, 108, 108);
	copy(119, 0, 18, 18, 457, 70, 108, 108);

}

// network #################################################################

void sendDataToServer(String name,float[] data)
{
   netstate=0;
   client = new Client(this, "127.0.0.1", 8080);        
   String strdata=encodeForServer(data);
   String cmd="POST /"+name+" HTTP/1.0\n";
   cmd+="Content-Type: application/x-www-form-urlencoded\n";
   cmd+="Content-Length: "+strdata.length()+"\n";
   cmd+="\n"+strdata+"\n";
   //println(cmd);
   client.write(cmd);
}

void requestSensorData(int sensor) {
	netstate=0;
	client = new Client(this, "127.0.0.1", 8080);        
        String cmd="GET /sense/"+str(sensor)+" HTTP/1.0\n\n";
        //println(cmd);
	client.write(cmd);
} 

Client client;
String netBuf="";
int netstate=-1;

void waitForAllContent()
{
  while(client.available()>0)
  {
  	  String data;
	  data=client.readString();
	  if(data!=null) netBuf=netBuf+data;
	  int p;
	  while((p=netBuf.indexOf("\n"))!=-1) {
                if(netstate==0)
                {
		  if(p==0) netstate=1;
                }
                else if(netstate==1)
                {
                  colorArray=float(netBuf.substring(0,p).split(","));
  		  netstate=2;
                }
                else if(netstate==2)
                {
                   float[] a=float(netBuf.substring(0,p).split(","));
				   for (int i=0; i<a.length; i++) {
						   micArray[i] = a[i]*micArrayScale;
				   }
                   netstate=3;
                }
                else if(netstate==3)
                {
                   
                   float[] a=float(netBuf.substring(0,p).split(","));
				   for (int i=0; i<a.length; i++) {
						   solarArray[i] = a[i];
				   }
                   netstate=4;
                }
                else if(netstate==4)
                {
                   float[] a=float(netBuf.substring(0,p).split(","));
				   for (int i=0; i<a.length; i++) {
						   tempArray[i] = a[i];
				   }
                   netstate=5;
                }
                else if(netstate==5)
                {
                   float[] a=float(netBuf.substring(0,p).split(","));
				   for (int i=0; i<a.length; i++) {
						   battArray[i] = a[i];
				   }
                   netstate=-1;
                }
		netBuf=netBuf.substring(p+1);
          }
  }
}


void sendAllDataToServer(float[] dgoto,float[] beep)
{
   client = new Client(this, "127.0.0.1", 8080);        
   String strdata="goto="+encodeForServer(dgoto)+"&beep="+encodeForServer(beep)+"\n";
   int len=strdata.length();
   String cmd="POST /all HTTP/1.0\n";   
   cmd+="Content-Type: application/x-www-form-urlencoded\n";
   cmd+="Content-Length: "+str(len)+"\n";
   cmd+="\n"+strdata;
   //println(cmd);
   client.write(cmd);
   netstate=0;
}

void sendAllDataFrame(float[] dgoto,float[] beep)
{
    if(netstate==-1) sendAllDataToServer(dgoto,beep);
    waitForAllContent();
}

void netFrame() {
  sendAllDataFrame(gotoArray,beepArray);
}

String encodeForServer(float[] a) {
    int i,j;
    String r="";
    String p="";
    for(i=0;i<a.length;i++)
      {
         if(i!=0) r+="%2C";
         p=str(int(a[i]));
         j=p.indexOf(".");
         if(j!=-1) p=p.substring(0,j)+"%2E"+p.substring(j+1);
         r+=p;
      }
   return r;
}


// Keyboard interface ##########################################################

void keyReleased() { 
	if (key == '0') content = 0; 
	if (key == '1') content = 1; 
	if (key == '2') content = 2; 
	if (key == '3') content = 3; 
	if (key == '4') content = 4; 
	if (key == '5') content = 5; 
	if (key == '6') content = 6; 
	if (key == '7') content = 7; 
	if (key == '8') content = 8; 
	if (key == '9') content = 9; 
	if (key == 'q') content = 10;
	if (key == 'w') content = 11;
	if (key == 'e') content = 12;
	if (key == 'r') content = 13;
	if (key == 't') content = 14;
	if (key == 'z') content = 15;
	if (key == 'u') content = 16;
	if (key == 'i') content = 17;
	if (key == 'o') content = 18;
	if (key == 'p') content = 19;
	
	if (key == 'x') {
		if (colorResolution < 33) colorResolution += 3;
	}
	if (key == 'c') {
		if (colorResolution > 3) colorResolution -= 3;
	}
	
	if (key == 'v') counterSpeed += 0.05;
	if (key == 'b') counterSpeed -= 0.05;
	if (key == 'n') micArrayScale *= 1.1;
	if (key == 'm') micArrayScale *= 0.9;
	
} 


